# Author: Dennis Wu
# Date: May 31, 2005
# Desciption: Run bds on all circuits.

set blifFiles [glob *.blif]
set blifFiles [lsort $blifFiles]

puts "running bds..."
foreach blifFile $blifFiles {
    set i [string length $blifFile]
    incr i -6
    set blifFileNoExt [string range $blifFile 0 $i]

    puts $blifFile
    if {[catch {exec {bds12} $blifFile ">" "${blifFileNoExt}.out"}] == 1} {
	catch {set blifDir [glob "${blifFileNoExt}_*"]}
	catch {set blifDir [lindex $blifDir 0]}
	catch {exec {rm} {-rf} $blifDir}
	continue;
    }

    # cp optimized blif file to *_opt.blif
    set blifDir [glob "${blifFileNoExt}_*"]
    set blifDir [lindex $blifDir 0]
    exec {cp} "${blifDir}/${blifFileNoExt}.final.blif" "${blifFileNoExt}_opt.blif"

    # remove directory created by bds
    exec {rm} {-rf} $blifDir
}
