# Author: Dennis Wu
# Date: May 31, 2005
# Description: Execute commands to synthesize circuits in current directory with bds, then technology map with praetor and sis mapper.  Results are reported in bds.csv.

# delete files from previous run
set blifFiles []
catch {set blifFiles [glob *.out]}
foreach blifFile $blifFiles {
    exec {rm} $blifFile
}
set blifFiles []
catch {set blifFiles [glob *_opt.blif]}
foreach blifFile $blifFiles {
    exec {rm} $blifFile
}

# Apply bds to all circuits in directory
source {../scripts/bds.tcl}

# Put runtime info in table
source {../scripts/getbdstime.tcl}
exec {mv} "runtime.csv" "results.csv"

# LUT technology mapping using praetor
source {../scripts/praetor.tcl}

# standard cell technology mapping using sis mapper
source {../scripts/sismap.tcl}

# Merge praetor.rpt and sismap.rpt into results.rpt
source {../scripts/mergecsvs.tcl}

# Final report including technology mapping results in fbdd.csv
exec {mv} {results.csv} {bds.csv}

