# Author: Dennis Wu
# Date: Feb 9, 2003
# Desciption: Apply FBDD to all circuits in current directory.
# and print summary of results in results.csv.

# Run FBDD on all circuits.
set blifFiles [glob *.blif]
#set remFiles {}
#set tempFiles {}
#catch {set remFiles [glob *_opt.blif]}
# remove *_opt.blif files from blifFiles
#foreach remFile $remFiles {
#    set idx [lsearch $blifFiles $remFile]
#    lvarpop $blifFiles idx
#}
set blifFiles [lsort -ascii $blifFiles]

foreach blifFile $blifFiles {
    
    set i [string length $blifFile]
    incr i -6
    set blifFileNoExt [string range $blifFile 0 $i]
    set outFile "${blifFileNoExt}.out"
    set fbddParams [list "" "" "" "" ""]
    set j 0
    set k 0
    puts "processing: $blifFile"

    # fill fbddParams
#    set work $env(fbddParams)
#    set workLength [string length $work]
#    puts "fbdd parameters: ${work}"
#    for {set j 0} {$j<$workLength} {incr j 1} {
#	if {[string index $work $j] == " "} then {
#	    incr k 1
#	} else {
#	    set fbddParams [lreplace $fbddParams $k $k "[lindex $fbddParams $k][string index $work $j]"]
#	}
#    }   

    puts "creating: .out ..."
    if { [file exists $outFile] != 1 } {
	exec {../../src/fbdd} [lindex $fbddParams 0] [lindex $fbddParams 1]  [lindex $fbddParams 2] [lindex $fbddParams 3] [lindex $fbddParams 4] $blifFile ">" $outFile
    }
}

# Summarize outputs in a table, results.csv
set outFiles [glob *.out]
set outFiles [lsort -ascii $outFiles]

set fResults [open "results.csv" w]
set numFiles 0

puts $fResults [format "%20s %5s %5s %5s %5s %5s %5s %5s %5s %5s %5s %5s %5s %5s %8s %8s %8s %8s" filename area tt te td tse nfd nrd nfe nre nfse1 nrse1 nfse2 nrse2 tweNS2 tweNS3 tweNS4 tweNS5]

foreach outFile $outFiles {
    # read data from out file
    set fOut [open $outFile r]
    
    while { [gets $fOut inLine] >=0 } {
	if {[string compare "SUMMARY" $inLine] == 0} {
	    break
	}
    }
    
    while { [gets $fOut inLine] >=0 } {
	# extractor size information
	if { [string compare $inLine {------------------------------------------------------------}] == 0} {
	    gets $fOut inLine
	    gets $fOut inLine
	    scan $inLine {%s %s %d %d %d %d} stra strb record(tweNS2) record(tweNS3) record(tweNS4) record(tweNS5)
	    gets $fOut inLine
	} elseif { [regexp {[a-zA-Z0-9 ]*[:][a-zA-Z0-9 ]*} $inLine] == 1} {
	    # get other info
	    scan $inLine {%[a-zA-Z0-9 ]: %s} param value
	    set record($param) $value
	} else {
	}
    }
    close $fOut

    set record(fn) $outFile
    set record(area) $record(AREA)
    set record(tt) $record(total time)
    set record(ts) $record(time sweep)
    set record(te) $record(time eliminate)
    set record(td) $record(time decompose)
    set record(tse) $record(time share extract)
    set record(nfe) $record(number folded eliminations)
    set record(nre) $record(number regular eliminations)
    set record(nfd) $record(number of folded decompositions)
    set record(nrd) $record(number of regular decompositions)
    set record(nfse1) $record(number folded extractor enumerations)
    set record(nrse1) $record(number regular extractor enumerations)
    set record(nfse2) $record(number folded remainder computation)
    set record(nrse2) $record(number regular remainder computation)

    puts $fResults [format "%20s %5s %5s %5s %5s %5s %5s %5s %5s %5s %5s %8s %8s %8s %8s %5s %5s %5s" \
	    $record(fn) $record(area) $record(tt) $record(te) $record(td) \
	    $record(tse) \
	    $record(nfd) $record(nrd) $record(nfe) $record(nre) \
	    $record(nfse1) $record(nrse1) \
	    $record(nfse2) $record(nrse2) \
	    $record(tweNS2) $record(tweNS3) $record(tweNS4) $record(tweNS5)
   ]
     
    incr numFiles 1
}

close $fResults

puts "done!"
