# Author: Dennis Wu
# Date: Apr 8, 2005
# Desciption: Performs area based FPGA technology mapping using rasp_syn's flowmap algorithm.  Summarizes lut count results in praetor.csv.

set lutSize 5
set blifFiles [glob *_opt.blif]
set blifFiles [lsort -ascii $blifFiles]

set fPreProcess [open flowmap.script w]

puts "flowmap..."

foreach blifFile $blifFiles {
    puts $fPreProcess "echo $blifFile"
    puts $fPreProcess "read_blif $blifFile"
    puts $fPreProcess "tech_decomp -a 1000 -o 1000"
    puts $fPreProcess "dmig -k 2"
    puts $fPreProcess "flowmap -k $lutSize"
    puts $fPreProcess "greedy_pack -m -k $lutSize"
    puts $fPreProcess "flowpack -k $lutSize"
    puts $fPreProcess "prn"
}
puts $fPreProcess "quit"

close $fPreProcess

catch {exec sis {-sx} {-f} flowmap.script {>} {flowmap.out}}

set fIn [open "flowmap.out" r]
set fOut [open "flowmap.csv" w]

puts $fOut [format "%30s %10s %10s" "Filename" "lv" "lc"]

while { [gets $fIn inLine] >=0 } {
    set ext [string range $inLine end-5 end]
    if {[string compare $ext {.blif }] == 0} {
	set circuit $inLine
	set level 0
	set lutcount 0
	# skip lines
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	
	scan $inLine {%d %d %d %d %d %d} level j2 j3 j4 j5 lutcount
	puts $fOut [format "%30s %10s %10s" $circuit $level $lutcount]
    }
}

close $fOut
close $fIn

puts "done!"


