# Author: Dennis Wu
# Date: June 2, 2005
# Desciption: Collect bds runtime from *.out files and tabulates results in
#             runtime.csv

set fOut [open "runtime.csv" w]

set outFiles [glob *.out]
set outFiles [lsort $outFiles]

set numFiles 0

puts $fOut [format "%20s %10s" filename time]
set networkTime "Total time used to do network preprocessing = "
set networkTimeLength [string length $networkTime]
set decompTime "Total time used to do BDD decomposition = "
set decompTimeLength [string length $decompTime]

foreach outFile $outFiles {
    # read data from out file

    set fIn [open $outFile r]
    
    while { [gets $fIn inLine] >=0 } {
	set prefix [string range $inLine 0 [expr $networkTimeLength - 1]]
	if {[string compare $prefix $networkTime] == 0} {
	    set inLine [string range $inLine $networkTimeLength end]
	    scan $inLine {%f} network
	    set network [expr $network * 1000]
	    continue
	} 

	set prefix [string range $inLine 0 [expr $decompTimeLength - 1]]
	if {[string compare $prefix $decompTime] == 0} {
	    set inLine [string range $inLine $decompTimeLength end]
	    scan $inLine {%f} decomp
	    set decomp [expr $decomp * 1000]
	    puts $fOut [format "%20s %10s" $outFile [expr $network + $decomp]]
	}
    }
    close $fIn
}

close $fOut

puts "done!"

