# Author: Dennis Wu
# Date: Apr 8, 2005
# Desciption: Performs area based FPGA technology mapping using rasp_syn's praetor algorithm.  Summarizes lut count results in praetor.csv.

set lutSize 4
set blifFiles [glob *_opt.blif]
set blifFiles [lsort -ascii $blifFiles]

set fPreProcess [open praetor.script w]

puts "praetor..."

foreach blifFile $blifFiles {
    puts $fPreProcess "echo $blifFile"
    puts $fPreProcess "read_blif $blifFile"
    puts $fPreProcess "tech_decomp -a 1000 -o 1000"
    puts $fPreProcess "dmig -k 2"
    puts $fPreProcess "praetor -k $lutSize -u 2 -o 0"
    puts $fPreProcess "greedy_pack -m -k $lutSize"
    puts $fPreProcess "flowpack -k $lutSize"
    puts $fPreProcess "prn"
}
puts $fPreProcess "quit"

close $fPreProcess

catch {exec sis {-sx} {-f} praetor.script {>} {praetor.out}}

set fIn [open "praetor.out" r]
set fOut [open "praetor.csv" w]

puts $fOut [format "%30s %10s" "Filename" "lc"]

while { [gets $fIn inLine] >=0 } {
    set ext [string range $inLine end-5 end]
    if {[string compare $ext {.blif }] == 0} {
	set circuit $inLine

	# skip lines
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	gets $fIn inLine
	
	scan $inLine {%d %d %d %d %d %d} j1 j2 j3 j4 j5 lutcount
	puts $fOut [format "%30s %10s" $circuit $lutcount]
    }
}

close $fOut
close $fIn

puts "done!"


