# Author: Dennis Wu
# Date: May 31, 2005
# Desciption: Generates the file "sisrun.script" and executes the script.

set script "script.rugged"
set blifFiles [glob *.blif]
set blifFiles [lsort $blifFiles]
set fOut [open "sisrun.script" w]

puts "creating sisrun.script..."
puts $fOut "time"
foreach blifFile $blifFiles {
    set i [string length $blifFile]
    incr i -6
    set blifFileNoExt [string range $blifFile 0 $i]
    puts $fOut "echo \"${blifFile}\""
    puts $fOut "read_blif ${blifFile}"
    puts $fOut "source ../scripts/${script}"
    puts $fOut "decomp"
    puts $fOut "tech_decomp -a 2 -o 2"
    puts $fOut "write_blif ${blifFileNoExt}_opt.blif"
    puts $fOut "time"
}
close $fOut

puts "running sis..."
catch {exec {sis} "-sx" "-f" "sisrun.script" ">" "sisrun.out"}
puts "done."
