# Author: Dennis Wu
# Date: Feb 9, 2003
# Desciption: Performs standard cell technology mapping using sis mapper and library lib2.genlib.  Area results are reported in sismap.csv.

set blifFiles [glob *_opt.blif]
set blifFiles [lsort -ascii $blifFiles]
set fPreProcess [open sismap.script w]

puts "sismap..."
puts $fPreProcess "read_library ../scripts/lib2.genlib"
foreach blifFile $blifFiles {
    puts $fPreProcess "echo \"File = $blifFile\""
    puts $fPreProcess "read_blif $blifFile"
    puts $fPreProcess "map -W -m 0"
    puts $fPreProcess "print_map_stats"
}
puts $fPreProcess "time"
puts $fPreProcess "quit"

close $fPreProcess

catch {exec {sis} {-sx} {-f} sismap.script {>} {sismap.out}}

set fIn [open "sismap.out" r]
set fOut [open "sismap.csv" w]
set preFilename {File = }
set preArea [format "Total Area\t\t= "]

puts $fOut [format "%15s %5s" "Filename" "area"]

set lengthPreFileName [string length $preFilename]
set lengthPreArea [string length $preArea]

while { [gets $fIn inLine] >=0 } {
    set str [string range $inLine 0 [expr $lengthPreFileName - 1]]
    if {[string compare $str $preFilename] == 0} {
	set filename [string range $inLine $lengthPreFileName end-1]
    }
    set str [string range $inLine 0 [expr $lengthPreArea - 1]]
    if {[string compare $str $preArea] == 0} {
	set area [string range $inLine $lengthPreArea end]
	puts $fOut [format "%15s %5s" $filename [expr $area]]
    }
}

close $fOut
close $fIn

#puts $preArea
puts "done!"

