/********************************************************************
 *		File			:		ierror.h
 *		Description		:		error handler interface
 *		Author			:		Jianwen Zhu
 *		Email			:		jzhu@eecg.toronto.edu
 *********************************************************************/
#ifndef IERROR_H
#define IERROR_H

#include "com.h"

#define COM_IERRORHANDLER_IID COM_DEFINE_GUID(		\
    0xbe65c148, 0xb514, 0x11d4, 					\
    0x8d, 0xc8, 0x00, 0x50, 0x56, 0xcb, 0x75, 0x4c	\
    )

COM_DECLARE_INTERFACE( ErrorHandler );

struct _DErrorHandler {
	COM_INHERIT_UNKNOWN( ErrorHandler );

	COMDECL		(*begin)( IErrorHandler ei );
	COMDECL		(*end)( IErrorHandler ei );
		
	COMDECL		(*getCoordinate)(
		IErrorHandler ei, char** pfile, Jint *pline,Jint* pcol
		);
	COMDECL		(*setCoordinate)(
		IErrorHandler ei, char* file, int line, int column
		);
	COMDECL		(*syntaxError)( IErrorHandler ei, char* format, ... );
	COMDECL		(*semanticError)( IErrorHandler ei, char* format, ... );
	COMDECL		(*internalError)( IErrorHandler ei, char* format, ... );
	COMDECL		(*fatalError)( IErrorHandler ei, char* format, ... );
	COMDECL		(*warning)(
		IErrorHandler ei, Jint level, char* format, ...
		);
	COMDECL		(*setWarningLevel)( IErrorHandler ei, int level );
	COMDECL		(*getNumOfErrors)( IErrorHandler ei, Jint *pnum );
	COMDECL		(*getNumOfWarnings)( IErrorHandler ei, Jint *pnum );
	};

extern IErrorHandler	ierror;
#endif
