/********************************************************************
 *		File			:		com.c
 *		Description		:		Microsoft COM registeration
 *		Author			:		Jianwen Zhu
 *		Reference		:		http://www.microsoft.com/com
 *		                 		oskit
 *		Email			:		jzhu@eecg.toronto.edu
 *********************************************************************/

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

#include "metautil.h"

COM_DECLARE_ADAM( Mem, heap );
COM_DECLARE_ADAM( MsgDigest, sha );
COM_DECLARE_ADAM( Lexicon, lex );
COM_DECLARE_ADAM( ErrorHandler, stderrhdl )
COM_DECLARE_ADAM( Service, service )

Value				comValue;

IService		iservice = NULL;
ILexicon		ilexicon = NULL;
IMem			iheap = NULL;
IMem			iarena = NULL;
IErrorHandler   ierror = NULL;
IMsgDigest		imd = NULL;

#if 0
static Jerror
constructGlobalRegistry( IMem mem ) {
	assert( mem );
	iservice = newService( mem );
	if( iservice == NULL )
		return COM_E_FAIL;
	return 0;
	}
#endif

Jerror
comBegin( void ) {
	iheap = &_iheap;
	imd = &_isha;
	ilexicon = &_ilex;
	ierror = &_istderrhdl;
	iservice = &_iservice;

	COM_ICALL( begin, ierror )( ierror );
	return 0;
	}

Jerror
comEnd( void ) {
	COM_ICALL( end, ierror )( ierror );
	return 0;
	}

Jboolean
comLittleEndian( void ) {
	int i = 0;
	
	((char *)(&i))[0] = 1;
	return (i == 1);
	}

