/*
 * Copyright (c) 2005 The University of Toronto and the Synthesis Group.
 * All rights reserved.
 * 
 * This file is part of the FBDD.  The FBDD is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Toronto at jzhu@eecg.toronto.edu or +1-416-946-5971.
 * 
 * The FBDD is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the FBDD; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

#include <assert.h>
#include "fbddutil.h"

COMDECL
_hashQuery(
	   IHashScheme si, const ComIID iid, IGeneric *i
	   ) {
  if( COM_SAME_IIDNAME( iid, UnKnown )
      || COM_SAME_IIDNAME( iid, HashScheme ) ) {
    *i = si;
    return 0;
  }
  *i = NULL;
  return COM_E_NOINTERFACE;
}

COMDECLU
_hashAddref( IHashScheme si ) {
  return 1;
}

COMDECLU
_hashRelease( IHashScheme si ) {
  return 1;
}
