/*
 * Copyright (c) 2005 The University of Toronto and the Synthesis Group.
 * All rights reserved.
 * 
 * This file is part of the FBDD.  The FBDD is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Toronto at jzhu@eecg.toronto.edu or +1-416-946-5971.
 * 
 * The FBDD is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the FBDD; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef SE_H
#define SE_H

#include "fbddopt.h"

typedef struct _SEExtrator
{
  BddInstance **bddis;
  extractType et;
  struct _List lBddis;
  ListCell lc;
} SEExtractor;

typedef struct _SERemainder 
{
  DdNode *bdd;
  int *oldIndexToNew;
  int arraySize;
  int numVars;
} SERemainder;

/* Remainder Cache Functions */
void serDestruct(SeManager sem, SERemainder *remainder);

void         sercConstruct(SeManager sem);
void         sercDestruct(SeManager sem);
DdNode*      sercGetSupport(SeManager sem, SEExtractor *see, 
		       BddInstance *bddi, int extSize);
DdNode*      sercGetSupportFromVars(SeManager sem, int *vars, int extSize);
SERemainder* sercFind(SeManager sem, DdNode *bddSupport, BddClass *bddc);
void         sercPut(SeManager sem, DdNode *bddSupport, 
		     BddClass *bddc, SERemainder *ser);
void         sercRemove(SeManager sem, DdNode *bddSupport, BddClass *bddc);
void         sercReleaseSupport(SeManager sem, DdNode *bddSupport);

#endif
