# Author: Dennis Wu
# Date: Feb 9, 2003
# Desciption: Apply FBDD to all circuits in current directory.
# and print summary of results in results.csv.

set srs {{algebraicDecompose decompAlg} {booleanDecompose decompBool} {bddDomDecompose decompBddDom} {nestedBddDecompose decompNestedBdd} {b2vdDecompose decompB2vd} {muxDecompose decompMux} {notDecompose decompNot} {boolXnorDecomp decompBoolXnor}}

# Run FBDD on all circuits.
set blifFiles [glob *.h *.c]
set blifFiles [lsort -dictionary $blifFiles]
set tempfile {xxtemp.tmp}

foreach blifFile $blifFiles {
    puts $blifFile

    set fAwk [open "sr.awk" w]

    puts $fAwk "{"
    foreach sr $srs { 
	set search [lindex $sr 0]
	set replace [lindex $sr 1]
	puts $fAwk  "gsub(\"$search\", \"$replace\");"
    }
    puts $fAwk "print > \"$tempfile\";"
    puts $fAwk "}"
    close $fAwk

    exec {awk} "-f" "sr.awk" $blifFile
#    exec {awk} "\{gsub(\"$search\", \"$replace\"); print > \"$tempfile\"\}" $blifFile
    exec {mv} $tempfile $blifFile
}

puts "done!"
